/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2006 by GJ Business Division RICOH COMPANY,LTD. JAPAN
 *  Copyright (C) 2007-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id$
 */

/*
 *  `bvˑW[iAT91SAM7Spj
 *
 *  J[l̃`bvˑ̃CN[ht@CDkernel_impl.h̃^[
 *  Qbgˑ̈ʒutƂȂD
 */

#ifndef TOPPERS_CHIP_CONFIG_H
#define TOPPERS_CHIP_CONFIG_H

/*
 *  `bvVXẽn[hEFA̒`
 */
#include "at91sam7s.h"

/*
 *  xN^[[`J[lŎ̒`
 */
#define VECTOR_KERNEL

/*
 *  xN^[[`Ȃꍇ̃xN^[AhX̐擪Ԓn
 */ 
#define VECTOR_START  0x00

/*
 * ݑ҂
 */
#define ASM_TARGET_WAIT_INTERRUPT nop

/*
 *  ASPJ[l쎞̃}bvƊ֘A`
 */
#define RAM_START       SRAM_BASE_ADDRESSS
#define RAM_SIZE        SRAM_SIZE

#define FIQ_DATA_SIZE   256U

/*
 *  ftHg̔^XNReLXgp̃X^bN̈̒`
 */
#define DEFAULT_ISTKSZ      0x1000U   /* 4KB */
#define DEFAULT_ISTK        (void *)(RAM_START+RAM_SIZE-FIQ_DATA_SIZE - DEFAULT_ISTKSZ)

                                                   
/*
 *  ԑ҂̂߂̒`i{SIL̃^[Qbgˑj
 */
#define SIL_DLY_TIM1    420
#define SIL_DLY_TIM2    195

/*
 *  ݃nhԍɊւ`
 */ 
#define TMIN_INHNO 0U
#define TMAX_INHNO 31U
#define TNUM_INH   32U

/*
 *  ݔԍɊւ`
 */ 
#define TMIN_INTNO 0U
#define TMAX_INTNO 31U
#define TNUM_INT   32U

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ݔԍ͈̔͂̔
 *
 *  rbgp^[߂̂eՂɂ邽߂ɁC8͌ԂɂȂĂD
 */
#define VALID_INTNO(intno) (TMIN_INTNO <= (intno) && (intno) <= TMAX_INTNO)
#define VALID_INTNO_DISINT(intno)	VALID_INTNO(intno)
#define VALID_INTNO_CFGINT(intno)	VALID_INTNO(intno)
#define VALID_INTNO_ATTISR(intno)   VALID_INTNO(intno)

/*
 *  ݃nh̓o^pe[u
 *   Ԃ̓RtBM[^Ő 
 */
extern const FP inh_tbl[TNUM_INH];

/*
 *  ݃nh̐ݒ
 */
Inline void
x_define_inh(INHNO inhno, FP int_entry)
{
}

/*
 *  ݃nh̏o̐}N
 *
 */
#define INT_ENTRY(inhno, inthdr)    inthdr
#define INTHDR_ENTRY(inhno, inhno_num, inthdr) extern void inthdr(void);

/*
 *  TOPPERSWݏf̎
 */

/*
 * e݂̊ݗv֎~tȌ
 */
extern uint32_t idf;

/*
 *  ݗDx}XN색Cu
 *
 *  AT91SAM7S͊ݗDx}XNIRCŃn[hEFAIɎC
 *  \tgEFAlǂݏłȂ߁Cݗv֎~t
 *  Oɂ芄ݗDx}XN
 */

/*
 *  ݂̊ݗDx}XN̒l
 */
extern PRI ipm;

/*
 *  ݗDx}XNɃZbgCݗv֎~tO̒l
 *  ̃e[u
 */
extern const uint32_t ipm_mask_tbl[8];

#endif /* TOPPERS_MACRO_ONLY */  

/*
 *  IPMimp_mask_tbl̃CfbNXɕϊ}N
 */
#define INDEX_IPM(ipm)  (-(ipm))

#ifndef TOPPERS_MACRO_ONLY

/*
 *  (f)ݗDx}XN̐ݒ
 * 
 *  w肳ꂽDxɐݒ肳ꂽݗv֎~tÕe[u̒lƁif
 *  ́je݂̊ݗv֎~tȌԂێϐ̒lƂ
 *  ORIRC̊ݗv֎~tOɃZbgCݒ肵Dxϐ
 *  ipmɕۑD
 */
Inline void
x_set_ipm(PRI intpri)
{
    uint32_t ipm_mask = ipm_mask_tbl[INDEX_IPM(intpri)];

    /*
     *  AT91SAM7S̊݃Rg[̓Cl[uWX^
     *  NA[WX^邽߁CUSĂ݂̊֎~ĂC
     *  ݂̊̂݋Kv
     */
    /* S݋֎~ */
    at91sam7s_disable_int(~0U);

    /* }XNw肳ĂȂ݂̂݋ */
    at91sam7s_enable_int(~(ipm_mask|idf));

    ipm = intpri;
}

#define t_set_ipm(intpri) x_set_ipm(intpri)
#define i_set_ipm(intpri) x_set_ipm(intpri)

/*
 *  (f)ݗDx}XN̎Q
 *
 *  ipm̒lԂ
 */
Inline PRI
x_get_ipm(void)
{
    return(ipm);
}

#define t_get_ipm() x_get_ipm()
#define i_get_ipm() x_get_ipm()

/*
 *  ݑݒ肳Ă邩𔻕ʂ邽߂̕ϐ
 */
extern uint32_t	bitpat_cfgint;

/*
 * if́jݗv֎~tÕZbg
 *
 *  w肳ꂽCݔԍ̊ݗv֎~tÕZbgāC݂
 *  ֎~D܂Cif́jݗv֎~tOǗidf̑
 *  rbgZbgD
 *  ݗv}XN@\T|[gĂȂꍇɂ́CfalseԂ
 */
Inline bool_t
x_disable_int(INTNO intno)
{
    if ((bitpat_cfgint & INTNO_BITPAT(intno)) == 0U) {
        return(false);
    }
    at91sam7s_disable_int(INTNO_BITPAT(intno));
    idf |= INTNO_BITPAT(intno);
    return(true);
}

#define t_disable_int(intno)  x_disable_int(intno)
#define i_disable_int(intno)  t_disable_int(intno)

/* 
 * (f)v֎~tỎ
 *
 * w肳ꂽCݔԍ̊ݗv֎~tÕNAāC݂
 * D܂Cif́jݗv֎~tOǗidf̑
 * rbgNAD
 * ݗv}XN@\T|[gĂȂꍇɂ́CfalseԂ
 */
Inline bool_t
x_enable_int(INTNO intno)
{
    if ((bitpat_cfgint & INTNO_BITPAT(intno)) == 0U) {
        return(false);
    }    
    at91sam7s_enable_int(INTNO_BITPAT(intno));
    idf &= ~INTNO_BITPAT(intno);
    return(true);
}

#define t_enable_int(intno) x_enable_int(intno)
#define i_enable_int(intno) x_enable_int(intno)

/*
 * ݗṽNA
 */
Inline void
x_clear_int(INTNO intno)
{
    at91sam7s_clear_int(INTNO_BITPAT(intno));
}

#define t_clear_int(intno) x_clear_int(intno) 
#define i_clear_int(intno) x_clear_int(intno) 


/*
 *  ݗṽ`FbN
 */
Inline bool_t
x_probe_int(INTNO intno)
{
    return(at91sam7s_probe_int(INTNO_BITPAT(intno)));
}

#define t_probe_int(intno) x_probe_int(intno)
#define i_probe_int(intno) x_probe_int(intno)

/*
 *  ݗvC̑̐ݒ
 *
 */
extern void    x_config_int(INTNO intno, ATR intatr, PRI intpri);

/*
 *  ݃nh̓ŕKvIRC
 *
 *  AT91SAM7Sł́CKvȏ͂Ȃ
 */
Inline void
i_begin_int(INTNO intno)
{
    
}

/*
 *  ݃nh̏oŕKvIRC
 *
 *  AT91SAM7Sł́CKvȏ͂Ȃ
 */
Inline void
i_end_int(INTNO intno)
{
    
}

/*
 *  ^[QbgVXeˑ̏
 */
extern void target_initialize(void);

/*
 *  ^[QbgVXȅI
 *
 *  VXeI鎞ɎgD
 */
extern void target_exit(void) NoReturn;

/*
 *  ݃nhichip_support.Sj
 */
extern void interrupt_handler(void);

/*
 *  `݂̊ꍇ̏
 */
extern void default_int_handler(void);

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  RAˑW[iARMpj
 */
#include "arm_gcc/nxt/core_config.h"

#endif /* TOPPERS_CHIP_CONFIG_H */
