/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: tSerialPortMain.c 439 2009-07-22 09:08:30Z ertl-takuya $
 */

/*
 *		VAC^tF[XhCo
 */

#include <kernel.h>
#include <t_syslog.h>
#include "tSerialPortMain_tecsgen.h"

/*
 *  t[Ɋ֘A萔ƃ}N
 */
#define	FC_STOP			'\023'		/* Rg[-S */
#define	FC_START		'\021'		/* Rg[-Q */

#define BUFCNT_STOP(bufsz)		((bufsz) * 3 / 4)	/* STOP𑗂 */
#define BUFCNT_START(bufsz)		((bufsz) / 2)		/* START𑗂 */

/*
 *  |C^̃CNg
 */
#define INC_PTR(ptr, bufsz)		{ if (++(ptr) == (bufsz)) { (ptr) = 0; }}

/*
 *  T[rXR[ďo}N
 *
 *  T[rXR[ďo܂ގexp]CԒlG[i̒lj̏
 *  ɂ́Cercercd_exp]lCerror_exitgotoD
 */
#define SVC(exp, ercd_exp) \
				{ if ((exp) < 0) { ercd = (ercd_exp); goto error_exit; }}

/*
 *  E_SYSG[̐
 */
static ER
gen_ercd_sys(CELLCB *p_cellcb)
{
	VAR_errorFlag = true;
	return(E_SYS);
}

/*
 *  ҂ɓT[rXR[̃G[̕ϊ
 */
static ER
gen_ercd_wait(ER rercd, CELLCB *p_cellcb)
{
	switch (MERCD(rercd)) {
	case E_RLWAI:
	case E_DLT:
		return(rercd);
	default:
		VAR_errorFlag = true;
		return(E_SYS);
	}
}

/*
 *  VA|[g̃I[vi󂯌֐j
 */
ER
eSerialPort_open(CELLIDX idx)
{
	CELLCB	*p_cellcb;
	ER		ercd;

	if (sns_dpn()) {				/* ReLXg̃`FbN */
		return(E_CTX);
	}
	if (!VALID_IDX(idx)) {
		return(E_ID);				/* |[gԍ̃`FbN */
	}
	p_cellcb = GET_CELLCB(idx);

	SVC(dis_dsp(), gen_ercd_sys(p_cellcb));
	if (VAR_openFlag) {				/* I[vς݂̃`FbN */
		ercd = E_OBJ;
	}
	else {
		/*
		 *  ϐ̏
		 */
		VAR_ioControl = (IOCTL_ECHO | IOCTL_CRLF | IOCTL_FCSND | IOCTL_FCRCV);

		VAR_receiveReadPointer = VAR_receiveWritePointer = 0U;
		VAR_receiveCount = 0U;
		VAR_receiveFlowControl = '\0';
		VAR_receiveStopped = false;

		VAR_sendReadPointer = VAR_sendWritePointer = 0U;
		VAR_sendCount = 0U;
		VAR_sendStopped = false;

		/*
		 *  ȍ~C݂֎~D
		 */
		if (loc_cpu() < 0) {
			ercd = E_SYS;
			goto error_exit_enadsp;
		}

		/*
		 *  n[hEFAˑ̃I[v
		 */
		cSIOPort_open();

		/*
		 *  MʒmR[obND
		 */
		cSIOPort_enableCBR(SIO_RDY_RCV);
		VAR_openFlag = true;
		VAR_errorFlag = false;

		if (unl_cpu() < 0) {
			VAR_errorFlag = true;
			ercd = E_SYS;
			goto error_exit_enadsp;
		}
		ercd = E_OK;
	}

  error_exit_enadsp:
	SVC(ena_dsp(), gen_ercd_sys(p_cellcb));

  error_exit:
	return(ercd);
}

/*
 *  VA|[g̃N[Yi󂯌֐j
 */
ER
eSerialPort_close(CELLIDX idx)
{
	CELLCB	*p_cellcb;
	ER		ercd;
	bool_t	eflag = false;

	if (sns_dpn()) {				/* ReLXg̃`FbN */
		return(E_CTX);
	}
	if (!VALID_IDX(idx)) {
		return(E_ID);				/* |[gԍ̃`FbN */
	}
	p_cellcb = GET_CELLCB(idx);

	SVC(dis_dsp(), gen_ercd_sys(p_cellcb));
	if (!VAR_openFlag) {			/* I[vς݂̃`FbN */
		ercd = E_OBJ;
	}
	else {
		/*
		 *  n[hEFAˑ̃N[Y
		 */
		if (loc_cpu() < 0) {
			eflag = true;
		}
		cSIOPort_close();
		VAR_openFlag = false;
		if (unl_cpu() < 0) {
			eflag = true;
		}

		/*
		 *  Z}tH̏
		 */
		if (cSendSemaphore_initialize() < 0) {
			eflag = true;
		}
		if (cReceiveSemaphore_initialize() < 0) {
			eflag = true;
		}

		/*
		 *  G[R[h̐ݒ
		 */
		if (eflag) {
			ercd = gen_ercd_sys(p_cellcb);
		}
		else {
			ercd = E_OK;
		}
	}
	SVC(ena_dsp(), gen_ercd_sys(p_cellcb));

  error_exit:
	return(ercd);
}

/*
 *  VA|[gւ̕M
 *
 *  p_cellcbŎw肳VAI/O|[gɑ΂āCc𑗐MD
 *  𑗐MWX^ɂꂽꍇɂtrueԂDłȂꍇɂ́C
 *  MWX^󂢂ƂʒmR[obN֐Cfalse
 *  D̊֐́CCPUbNԂŌĂяoD
 */
Inline bool_t
serialPort_snd_chr(CELLCB *p_cellcb, char_t c)
{
	if (cSIOPort_putChar(c)) {
		return(true);
	}
	else {
		cSIOPort_enableCBR(SIO_RDY_SND);
		return(false);
	}
}

/*
 *  VA|[gւ1M
 */
static ER_BOOL
serialPort_wri_chr(CELLCB *p_cellcb, char_t c)
{
	bool_t	buffer_full;
	ER		ercd, rercd;

	/*
	 *  LF̑OCR𑗐MD
	 */
	if (c == '\n' && (VAR_ioControl & IOCTL_CRLF) != 0U) {
		SVC(rercd = serialPort_wri_chr(p_cellcb, '\r'), rercd);
		if ((bool_t) rercd) {
			SVC(rercd = cSendSemaphore_wait(),
										gen_ercd_wait(rercd, p_cellcb));
		}
	}

	SVC(loc_cpu(), gen_ercd_sys(p_cellcb));
	if (VAR_sendCount == 0U && !VAR_sendStopped
								&& serialPort_snd_chr(p_cellcb, c)) {
		/*
		 *  VAI/OfoCX̑MWX^ɕ邱Ƃɐ
		 *  ꍇD
		 */
		buffer_full = false;
	}
	else {
		/*
		 *  Mobt@ɕD
		 */
		VAR_sendBuffer[VAR_sendWritePointer] = c;
		INC_PTR(VAR_sendWritePointer, ATTR_sendBufferSize);
		VAR_sendCount++;
		buffer_full = (VAR_sendCount == ATTR_sendBufferSize);
	}

	SVC(unl_cpu(), gen_ercd_sys(p_cellcb));
	ercd = (ER_BOOL) buffer_full;

  error_exit:
	return(ercd);
}

/*
 *  VA|[gւ̕񑗐Mi󂯌֐j
 */
ER_UINT
eSerialPort_write(CELLIDX idx, const char_t *buffer, uint_t length)
{
	CELLCB	*p_cellcb;
	bool_t	buffer_full;
	uint_t	wricnt = 0U;
	ER		ercd, rercd;

	if (sns_dpn()) {				/* ReLXg̃`FbN */
		return(E_CTX);
	}
	if (!VALID_IDX(idx)) {			/* |[gԍ̃`FbN */
		return(E_ID);
	}

	p_cellcb = GET_CELLCB(idx);
	if (!VAR_openFlag) {			/* I[vς݂̃`FbN */
		return(E_OBJ);
	}
	if (VAR_errorFlag) {			/* G[Ԃ̃`FbN */
		return(E_SYS);
	}

	buffer_full = true;				/* [v1߂wai_sem */
	while (wricnt < length) {
		if (buffer_full) {
			SVC(rercd = cSendSemaphore_wait(),
										gen_ercd_wait(rercd, p_cellcb));
		}
		SVC(rercd = serialPort_wri_chr(p_cellcb, *buffer++), rercd);
		wricnt++;
		buffer_full = (bool_t) rercd;
	}
	if (!buffer_full) {
		SVC(cSendSemaphore_signal(), gen_ercd_sys(p_cellcb));
	}
	ercd = E_OK;

  error_exit:
	return(wricnt > 0U ? (ER_UINT) wricnt : ercd);
}

/*
 *  VA|[g1M
 */
static bool_t
serialPort_rea_chr(CELLCB *p_cellcb, char_t *p_c)
{
	bool_t	buffer_empty;
	ER		ercd;

	SVC(loc_cpu(), gen_ercd_sys(p_cellcb));

	/*
	 *  Mobt@當oD
	 */
	*p_c = VAR_receiveBuffer[VAR_receiveReadPointer];
	INC_PTR(VAR_receiveReadPointer, ATTR_receiveBufferSize);
	VAR_receiveCount--;
	buffer_empty = (VAR_receiveCount == 0U);

	/*
	 *  START𑗐MD
	 */
	if (VAR_receiveStopped && VAR_receiveCount <= BUFCNT_START(ATTR_receiveBufferSize)) {
		if (!serialPort_snd_chr(p_cellcb, FC_START)) {
			VAR_receiveFlowControl = FC_START;
		}
		VAR_receiveStopped = false;
	}

	SVC(unl_cpu(), gen_ercd_sys(p_cellcb));
	ercd = (ER_BOOL) buffer_empty;

  error_exit:
	return(ercd);
}

/*
 *  VA|[g̕Mi󂯌֐j
 */
ER_UINT
eSerialPort_read(CELLIDX idx, char_t *buffer, uint_t length)
{
	CELLCB	*p_cellcb;
	bool_t	buffer_empty;
	uint_t	reacnt = 0U;
	char_t	c = '\0';		/* RpČx}~邽߂ɏ */
	ER		ercd, rercd;

	if (sns_dpn()) {				/* ReLXg̃`FbN */
		return(E_CTX);
	}
	if (!VALID_IDX(idx)) {			/* |[gԍ̃`FbN */
		return(E_ID);
	}

	p_cellcb = GET_CELLCB(idx);
	if (!VAR_openFlag) {			/* I[vς݂̃`FbN */
		return(E_OBJ);
	}
	if (VAR_errorFlag) {			/* G[Ԃ̃`FbN */
		return(E_SYS);
	}

	buffer_empty = true;			/* [v1߂wai_sem */
	while (reacnt < length) {
		if (buffer_empty) {
			SVC(rercd = cReceiveSemaphore_wait(),
										gen_ercd_wait(rercd, p_cellcb));
		}
		SVC(rercd = serialPort_rea_chr(p_cellcb, &c), rercd);
		*buffer++ = c;
		reacnt++;
		buffer_empty = (bool_t) rercd;

		/*
		 *  GR[obND
		 */
		if ((VAR_ioControl & IOCTL_ECHO) != 0U) {
			SVC(rercd = cSendSemaphore_wait(),
										gen_ercd_wait(rercd, p_cellcb));
			SVC(rercd = serialPort_wri_chr(p_cellcb, c), rercd);
			if (!((bool_t) rercd)) {
				SVC(cSendSemaphore_signal(), gen_ercd_sys(p_cellcb));
			}
		}
	}
	if (!buffer_empty) {
		SVC(cReceiveSemaphore_signal(), gen_ercd_sys(p_cellcb));
	}
	ercd = E_OK;

  error_exit:
	return(reacnt > 0U ? (ER_UINT) reacnt : ercd);
}

/*
 *  VA|[g̐i󂯌֐j
 */
ER
eSerialPort_control(CELLIDX idx, uint_t ioctl)
{
	CELLCB	*p_cellcb;

	if (sns_dpn()) {				/* ReLXg̃`FbN */
		return(E_CTX);
	}
	if (!VALID_IDX(idx)) {
		return(E_ID);				/* |[gԍ̃`FbN */
	}

	p_cellcb = GET_CELLCB(idx);
	if (!VAR_openFlag) {			/* I[vς݂̃`FbN */
		return(E_OBJ);
	}
	if (VAR_errorFlag) {			/* G[Ԃ̃`FbN */
		return(E_SYS);
	}

	VAR_ioControl = ioctl;
	return(E_OK);
}

/*
 *  VA|[gԂ̎QƁi󂯌֐j
 */
ER
eSerialPort_refer(CELLIDX idx, T_SERIAL_RPOR* pk_rpor)
{
	CELLCB	*p_cellcb;

	if (sns_dpn()) {				/* ReLXg̃`FbN */
		return(E_CTX);
	}
	if (!VALID_IDX(idx)) {
		return(E_ID);				/* |[gԍ̃`FbN */
	}

	p_cellcb = GET_CELLCB(idx);
	if (!VAR_openFlag) {			/* I[vς݂̃`FbN */
		return(E_OBJ);
	}
	if (VAR_errorFlag) {			/* G[Ԃ̃`FbN */
		return(E_SYS);
	}

	pk_rpor->reacnt = VAR_receiveCount;
	pk_rpor->wricnt = VAR_sendCount;
	return(E_OK);
}

/*
 *  VA|[g̑M\R[obNi󂯌֐j
 */
void
eiSIOCBR_readySend(CELLIDX idx)
{
	CELLCB	*p_cellcb;

	assert(VALID_IDX(idx));
	p_cellcb = GET_CELLCB(idx);
	if (VAR_receiveFlowControl != '\0') {
		/*
		 *  START/STOP 𑗐MD
		 */
		(void) cSIOPort_putChar(VAR_receiveFlowControl);
		VAR_receiveFlowControl = '\0';
	}
	else if (!VAR_sendStopped && VAR_sendCount > 0U) {
		/*
		 *  Mobt@當ođMD
		 */
		(void) cSIOPort_putChar(VAR_sendBuffer[VAR_sendReadPointer]);
		INC_PTR(VAR_sendReadPointer, ATTR_sendBufferSize);
		if (VAR_sendCount == ATTR_sendBufferSize) {
			if (ciSendSemaphore_signal() < 0) {
				VAR_errorFlag = true;
			}
		}
		VAR_sendCount--;
	}
	else {
		/*
		 *  MׂȂꍇ́CM\R[obN֎~D
		 */
		cSIOPort_disableCBR(SIO_RDY_SND);
	}
}

/*
 *  VA|[g̎MʒmR[obNi󂯌֐j
 */
void
eiSIOCBR_readyReceive(CELLIDX idx)
{
	CELLCB	*p_cellcb;
	char_t	c;

	assert(VALID_IDX(idx));
	p_cellcb = GET_CELLCB(idx);
	c = (char_t) cSIOPort_getChar();
	if ((VAR_ioControl & IOCTL_FCSND) != 0U && c == FC_STOP) {
		/*
		 *  Mꎞ~DM͂̂̕܂ܑMD
		 */
		VAR_sendStopped = true;
	}
	else if (VAR_sendStopped && (c == FC_START
				|| (VAR_ioControl & IOCTL_FCANY) != 0U)) {
		/*
		 *  MĊJD
		 */
		VAR_sendStopped = false;
		if (VAR_sendCount > 0U) {
			c = VAR_sendBuffer[VAR_sendReadPointer];
			if (serialPort_snd_chr(p_cellcb, c)) {
				INC_PTR(VAR_sendReadPointer, ATTR_sendBufferSize);
				if (VAR_sendCount == ATTR_sendBufferSize) {
					if (ciSendSemaphore_signal() < 0) {
						VAR_errorFlag = true;
					}
				}
				VAR_sendCount--;
			}
		}
	}
	else if ((VAR_ioControl & IOCTL_FCSND) != 0U && c == FC_START) {
		/*
		 *  Mɑ΂ăt[䂵ĂꍇCSTART ͎̂ĂD
		 */
	}
	else if (VAR_receiveCount == ATTR_receiveBufferSize) {
		/*
		 *  obt@t̏ꍇCM̂ĂD
		 */
	}
	else {
		/*
		 *  MMobt@ɓD
		 */
		VAR_receiveBuffer[VAR_receiveWritePointer] = c;
		INC_PTR(VAR_receiveWritePointer, ATTR_receiveBufferSize);
		if (VAR_receiveCount == 0U) {
			if (ciReceiveSemaphore_signal() < 0) {
				VAR_errorFlag = true;
			}
		}
		VAR_receiveCount++;

		/*
		 *  STOP𑗐MD
		 */
		if ((VAR_ioControl & IOCTL_FCRCV) != 0U && !VAR_receiveStopped
						&& VAR_receiveCount >= BUFCNT_STOP(ATTR_receiveBufferSize)) {
			if (!serialPort_snd_chr(p_cellcb, FC_STOP)) {
				VAR_receiveFlowControl = FC_STOP;
			}
			VAR_receiveStopped = true;
		}
	}
}

/*
 *  VAC^tF[XhCo̖M̎o
 */
bool_t
enSerialPort_getChar(CELLIDX idx, char_t *p_c)
{
	CELLCB	*p_cellcb;

	if (VALID_IDX(idx)) {						/* |[gԍ̃`FbN */
		p_cellcb = GET_CELLCB(idx);
		if (VAR_openFlag) {						/* I[vς݂̃`FbN */
			if (VAR_sendCount > 0U) {
				*p_c = VAR_sendBuffer[VAR_sendReadPointer];
				INC_PTR(VAR_sendReadPointer, ATTR_sendBufferSize);
				VAR_sendCount--;
				return(true);
			}
		}
	}
	return(false);
}
