/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: tSysLog.c 439 2009-07-22 09:08:30Z ertl-takuya $
 */

/*
 *		VXeO@\
 */

#include "tSysLog_tecsgen.h"
#include <sil.h>
#include <t_syslog.h>
#include <log_output.h>

/*
 *  ݂̃VXe
 *
 *  Oo߂ɁCނȂCJ[l̓ϐQƂĂ
 *  D
 */
extern ulong_t	_kernel_current_time;

/*
 *  ჌xo͂̌ďo֐
 */
static void
low_putchar(char_t c)
{
	cPutLog_putChar(c);
}

/* 
 *  Ȍo
 *
 *  CPUbNԂsReLXgɂ炸ł悤ɎĂD
 */
ER
eSysLog_write(uint_t priority, const SYSLOG *p_syslog)
{
	SIL_PRE_LOC;

	SIL_LOC_INT();

	/*
	 *  O̐ݒ
	 */
	((SYSLOG *) p_syslog)->logtim = _kernel_current_time;

	/*
	 *  Oobt@ɋL^
	 */
	if ((VAR_logMask & LOG_MASK(priority)) != 0U) {
		VAR_logBuffer[VAR_tail] = *p_syslog;
		VAR_tail++;
		if (VAR_tail >= ATTR_logBufferSize) {
			VAR_tail = 0U;
		}
		if (VAR_count < ATTR_logBufferSize) {
			VAR_count++;
		}
		else {
			VAR_head = VAR_tail;
			VAR_lost++;
		}
	}

	/*
	 *  ჌xo
	 */
	if ((VAR_lowMask & LOG_MASK(priority)) != 0U) {
		syslog_print(p_syslog, low_putchar);
		low_putchar('\n');
	}

	SIL_UNL_INT();
	return(E_OK);
}

/*
 *  Oobt@̓Ǐo
 *
 *  CPUbNԂsReLXgɂ炸ł悤ɎĂD
 */
ER_UINT
eSysLog_read(SYSLOG *p_syslog)
{
	ER_UINT	ercd;
	SIL_PRE_LOC;

	SIL_LOC_INT();

	/*
	 *  Oobt@̎o
	 */
	if (VAR_count > 0U) {
		*p_syslog = VAR_logBuffer[VAR_head];
		VAR_count--;
		VAR_head++;
		if (VAR_head >= ATTR_logBufferSize) {
			VAR_head = 0U;
		}
		ercd = (ER_UINT) VAR_lost;
		VAR_lost = 0U;
	}
	else {
		ercd = E_OBJ;
	}

	SIL_UNL_INT();
	return(ercd);
}

/* 
 *  oׂ͂Ȍdvx̐ݒ
 */
ER
eSysLog_mask(uint_t logMask, uint_t lowMask)
{
	VAR_logMask = logMask;
	VAR_lowMask = lowMask;
	return(E_OK);
}

/*
 *  Oobt@̏ԎQ
 */
ER_UINT
eSysLog_refer(T_SYSLOG_RLOG *pk_rlog)
{
	SIL_PRE_LOC;

	SIL_LOC_INT();

	pk_rlog->count = VAR_count;
	pk_rlog->lost = VAR_lost;
	pk_rlog->logmask = VAR_logMask;
	pk_rlog->lowmask = VAR_lowMask;

	SIL_UNL_INT();
	return(E_OK);
}
