/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2006 by GJ Business Division RICOH COMPANY,LTD. JAPAN  
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: target_serial.h 948 2008-04-14 08:34:27Z ertl-honda $
 */

/*
 * VAI/OfoCXiSIOjhCoimindstorms_nxtpj
 */

#ifndef TOPPERS_TARGET_SERIAL_H
#define TOPPERS_TARGET_SERIAL_H

#include "arm_gcc/nxt/at91sam7s.h"

/*
 *  SIO̊݃nh̃xN^ԍ
 */
#define INHNO_SIO        INTNO_US1_PID /* ݃nhԍ */
#define INTNO_SIO        INTNO_US1_PID /* ݔԍ */
#define INTPRI_SIO       -2               /* ݗDx */
#define INTATR_SIO       0U               /* ݑ */

/*
 *  VAI/O|[g̒`
 */
#define TNUM_SIOP		1		/* T|[gVAI/O|[g̐ */

#define TADR_US1_BASE 0xFFFC4000

#define US_ENDRX 0x0008
#define US_TXBUFE 0x0800
#define US_RXBUFF 0x01000

/*
 *  Mobt@
 */
#define SND_BUF_SIZE 128

/*
 *  Mobt@
 */
#define RCV_BUF_SIZE 1

#ifndef TOPPERS_MACRO_ONLY

/*
 *  VAI/O|[gǗubN̒`
 */
typedef struct sio_port_control_block	SIOPCB;

/*
 *  SIOhCȍ
 */
extern void sio_initialize(intptr_t exinf);

/*
 *  SIOhCȍI
 */
extern void sio_terminate(intptr_t exinf);

/*
 *  VAI/O|[g̃I[v
 */
extern SIOPCB *sio_opn_por(ID siopid, intptr_t exinf);

/*
 *  VAI/O|[g̃N[Y
 */
extern void sio_cls_por(SIOPCB *p_siopcb);

/*
 *  SIO̊݃nh
 */
extern void sio_isr(intptr_t exinf);

/*
 *  VAI/O|[gւ̕M
 */
extern bool_t sio_snd_chr(SIOPCB *siopcb, char_t c);

/*
 *  VAI/O|[g̕M
 */
extern int_t sio_rcv_chr(SIOPCB *siopcb);

/*
 *  VAI/O|[g̃R[obN̋
 */
extern void sio_ena_cbr(SIOPCB *siopcb, uint_t cbrtn);

/*
 *  VAI/O|[g̃R[obN̋֎~
 */
extern void sio_dis_cbr(SIOPCB *siopcb, uint_t cbrtn);

/*
 *  VAI/O|[g̑M\R[obN
 */
extern void sio_irdy_snd(intptr_t exinf);

/*
 *  VAI/O|[g̎MʒmR[obN
 */
extern void sio_irdy_rcv(intptr_t exinf);

/*
 *  bluetoothڑ
 */
extern uint8_t ecrobot_get_bt_status(void);

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_TARGET_SERIAL_H */
