/*
 *   TOPPERS Software
 *       Toyohashi Open Platform for Embedded Real-Time Systems
 *  
 *   Copyright (C) 2010 by Embedded and Real-Time Systems Laboratory
 *               Graduate School of Information Science, Nagoya Univ., JAPAN
 *  
 *   L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *   Ai{\tgEFAς̂܂ށDȉjgpEE
 *   ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *   (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *       \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *       XR[hɊ܂܂Ă邱ƁD
 *   (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *       pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *       ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *       ̖ۏ؋Kfڂ邱ƁD
 *   (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *       płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *       ƁD
 *     (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *         쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *     (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *         񍐂邱ƁD
 *   (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *       QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *       ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *       RɊÂCL쌠҂TOPPERSvWFNg
 *       Ɛӂ邱ƁD
 *  
 *   {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *   TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *   ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *   A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *   ̐ӔC𕉂ȂD
 *
 */
/* #[<PREAMBLE>]#
 * #[<...>]# AHA#[</...>]# ň͂܂ꂽRg͕ҏWȂł
 * tecsmerge ɂ}[WɎgp܂
 *
 * Ăь֐ #_TCPF_#
 * require port : signature: sKernel context: task
 *   ER             sleep( );
 *   ER             sleepTimeout( TMO timeout );
 *   ER             delay( RELTIM delayTime );
 *   ER             exitTask( );
 *   ER             getTaskId( ID* p_taskId );
 *   ER             rotateReadyQueue( PRI taskPriority );
 *   ER             getTime( SYSTIM* p_systemTime );
 *   ER             getMicroTime( SYSUTM* p_systemMicroTime );
 *   ER             lockCpu( );
 *   ER             unlockCpu( );
 *   ER             disableDispatch( );
 *   ER             enableDispatch( );
 *   ER             disableTaskException( );
 *   ER             enableTaskException( );
 *   ER             changeInterruptPriorityMask( PRI interruptPriority );
 *   ER             getInterruptPriorityMask( PRI* p_interruptPriority );
 *   ER             exitKernel( );
 *   bool_t         senseContext( );
 *   bool_t         senseLock( );
 *   bool_t         senseDispatch( );
 *   bool_t         senseDispatchPendingState( );
 *   bool_t         senseKernel( );
 * call port : cButton  signature: sNXTButton context: task
 *   void           cButton_pollingUpdateNXTState( );
 *   bool_t         cButton_isENTERButton( );
 *   bool_t         cButton_isRUNButton( );
 *   bool_t         cButton_isSTOPButton( );
 *   bool_t         cButton_isEXITButton( );
 *   uint8_t        cButton_getButtonState( );
 * call port : cCyclic  signature: sCyclic context: task
 *   ER             cCyclic_start( );
 *   ER             cCyclic_stop( );
 *   ER             cCyclic_refer( T_RCYC* pk_cyclicHandlerStatus );
 * call port : cDisplay  signature: sDisplay context: task
 *   void           cDisplay_update( );
 *   void           cDisplay_clear( bool_t updateToo );
 *   void           cDisplay_gotoXY( int_t x, int_t y );
 *   void           cDisplay_putChar( char_t c );
 *   void           cDisplay_putString( const char_t* string );
 *   void           cDisplay_putInt( int32_t val, uint32_t places );
 *   void           cDisplay_putUnsigned( uint32_t val, uint32_t places );
 *   void           cDisplay_putHex( uint32_t val, uint32_t places );
 *   uint8_t*       cDisplay_getBuffer( );
 *   void           cDisplay_powerOff( bool_t updateToo );
 *   void           cDisplay_copyBitmap( const uint8_t* data, uint32_t width, uint32_t depth, uint32_t x, uint32_t y );
 * call port : cAVR  signature: sAVR context: task
 *   void           cAVR_update( );
 *   void           cAVR_setMotor( uint32_t portNumber, int32_t powerPercent, int32_t brake );
 *   void           cAVR_powerDown( );
 *   uint32_t       cAVR_getButton( );
 *   uint32_t       cAVR_batteryVoltage( );
 *   uint32_t       cAVR_getSensor( uint32_t portNumber );
 *   void           cAVR_setInputPower( uint32_t portNumber, uint32_t powerType );
 *
 * #[</PREAMBLE>]# */

#include "tCheckNXTButtonBody_tecsgen.h"
#include <sil.h>

#ifndef E_OK
#define	E_OK	0		/* success */
#define	E_ID	(-18)	/* illegal ID */
#endif

extern void target_stop(void);

/* :֐ #_TEPF_# */
/* #[<ENTRY_PORT>]# eiCyclic
 * entry port: eiCyclic
 * signature:  siHandlerBody
 * context:    non-task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eiCyclic_main
 * name:         eiCyclic_main
 * global_name:  tCheckNXTButtonBody_eiCyclic_main
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eiCyclic_main(CELLIDX idx)
{
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}

	cButton_pollingUpdateNXTState();

	if(cButton_isSTOPButton()){
		cCyclic_stop();
		if(is_cDisplay_joined()){
			cDisplay_powerOff(0);
		}
		
		/* jump to the entry of application */
		target_stop();
	} else if(cButton_isEXITButton()){
		cCyclic_stop();

		/* Id؂ */
		exitKernel();
	}
}

/* #[<POSTAMBLE>]#
 *   AEA導g[CWSCC
 * #[</POSTAMBLE>]#*/
