#
#  TECS Generator
#      Generator for TOPPERS Embedded Component System
#  
#   Copyright (C) 2008-2009 by TOPPERS Project
#--
#   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#   ܥեȥѤΤޤࡥʲƱˤѡʣ
#   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#       ˴ޤޤƤ뤳ȡ
#   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#       ѤǤǺۤˤϡۤȼɥȡ
#       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#       ̵ݾڵǺܤ뤳ȡ
#   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#       ѤǤʤǺۤˤϡΤ줫ξ
#       ȡ
#     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#         𤹤뤳ȡ
#   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#       դ뤳ȡ
#  
#   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#   TOPPERSץȤϡܥեȥ˴ؤơλŪ
#   ФŬޤơʤݾڤԤʤޤܥեȥ
#   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#   Ǥʤ
#  
#   $Id: expression.rb 92 2008-05-26 01:43:38Z okuma-top $
#++

#= BaseVal ưʤɤͤ򰷤饹δ쥯饹
#
# TECS  CDL ǰͤϡʲʬव
# 
# ư
# ʸ
# ֡
# ʹ¤Ρˤ C_EXP ϤǤϰʤ
#
# Υ饹Ѥߤα黻Ҥϡ顼Ȥʤ
# ˤ黻ǽʾ硢黻Ҥ򥪡С饤ɤ
#
class BaseVal
  def ~@
    unsupport "~"
  end
  def -@
    unsupport "unary -"
  end
  def +@
    unsupport "unary +"
  end
  def not # ! val
    unsupport "!"
  end

  def * val
    unsupport "*"
  end
  def / val
    unsupport "/"
  end
  def % val
    unsupport "%"
  end
  def + val
    unsupport "+"
  end
  def - val
    unsupport "-"
  end
  def << val
    unsupport "<<"
  end
  def >> val
    unsupport ">>"
  end
  def > val
    unsupport ">"
  end
  def < val
    unsupport "<"
  end
  def >= val
    unsupport ">="
  end
  def <= val
    unsupport "<="
  end
  def eq val # == val
    unsupport "=="
  end
  def neq val # != val
    unsupport "!="
  end
  def & val
    unsupport "&"
  end
  def ^ val
    unsupport "^"
  end
  def | val
    unsupport "|"
  end
  def lAND # && val
    unsupport "&&"
  end
  def lOR  # || val
    unsupport "||"
  end
  def cast( type )
    unsupport "CAST"
  end

  def unsupport op
    Generator.error( "#{op}: unable for #{self.class}" )
  end

  def to_s
    raise "to_s not overridden"
  end

  def to_i
    Generator.error( "#{self.class}: cannot cast to integer (implicitly)" )
    1
  end
  def to_f
    Generator.error( "#{self.class}: cannot cast to float (implicitly)" )
    1.0
  end
end

#= Pointer  (IntegerVal  Pointer )
#
# ݥͤϡCDL ľ뤳ȤϤʤ
# ͤΥ㥹ȱ黻ˤ
class PointerVal < BaseVal
#@int_val:: IntegerVal: IntegerVal ǤʤƤϤʤʤ
#@ptr_type:: PtrType: ݥ󥿤λؤη

  def initialize( int_val, ptr_type )
    @int_val = int_val
    @ptr_type = ptr_type
  end

  #=== ݥ󥿤λؤη
  # PointerVal ѤΥ᥽å
  def get_type
    @ptr_type
  end

  def cast type
    t = type.get_original_type   # typedef θ
    if t.kind_of? IntType then
      val = t.check_and_clip( @int_val, :IntType )
      return IntegerVal.new( val )
    elsif t.kind_of? FloatType then
      Generator.error( "Cannot cast pointer to float" )
      return FloatVal.new( @int_val )
    elsif t.kind_of? PtrType then
      return PointerVal.new( @int_val, type )
    else
      Generator.error( "pointer value cannot cast to #{type.class}" )
      return nil
    end
  end

  def to_s
    "(#{@ptr_type.get_type_str}#{@ptr_type.get_type_str_post})#{sprintf("0x%X", @int_val)}"
  end

  def to_i
    Generator.error( "convert pointer value to integer without cast" )
    raise "hoge"
    @val.to_i
  end
end

#= IntegerVal: ͤ򰷤饹
class IntegerVal < BaseVal
#@val:: Integer: value
#@str:: string: literal
#@sign:: Symbol: :SIGNED | :UNSIGNED
#@size:: Symbol: :NORMAL | :SHORT | :LONG | :LONGLONG

  def initialize( val, str = nil, sign = :SIGNED, size = :NORMAL )
    @val = val.to_i
    @str = str
    @sign = sign
    @size = size
  end

  def ~@
    IntegerVal.new( ~ @val )
  end
  def -@
    IntegerVal.new( - @val )
  end
  def +@
    self
  end
  def not # !
      BoolVal.new( ! @val )
  end

  def * val
    if val.kind_of? FloatVal then
      return FloatVal.new( @val.to_f * val.to_f )
    else
      return IntegerVal.new( @val * val.to_i )
    end
  end
  def / val
    if val.kind_of? FloatVal then
      v2 = val.to_f   # to_f 2ɾʤ
      if v2 == 0.0 then
        Generator.error( "/ : divieded by zero" )
        return FloatVal.new( 1.0 )
      end
      return FloatVal.new( @val.to_f / v2 )
    else
      v2 = val.to_i   # to_i 2ɾʤ
      if v2 == 0 then
        Generator.error( "/ : divieded by zero" )
        return IntegerVal.new( 1 )
      end
      return IntegerVal.new( @val / v2 )
    end
  end
  def % val
    if val.kind_of? FloatVal then
      v2 = val.to_f   # to_f 2ɾʤ
      if v2 == 0.0 then
        Generator.error( "% : divieded by zero" )
        return FloatVal.new( 1.0 )
      end
      return FloatVal.new( @val.to_f % v2 )
    else
      v2 = val.to_i   # to_i 2ɾʤ
      if v2 == 0 then
        Generator.error( "% : divieded by zero" )
        return IntegerVal.new( 1 )
      end
      return IntegerVal.new( @val % v2 )
    end
  end
  def + val
    if val.kind_of? FloatVal then
      return FloatVal.new( @val.to_f + val.to_f )
    else
      return IntegerVal.new( @val + val.to_i )
    end
  end
  def - val
    if val.kind_of? FloatVal then
      return FloatVal.new( @val.to_f - val.to_f )
    else
      return IntegerVal.new( @val - val.to_i )
    end
  end
  def << val
    return IntegerVal.new( @val << val.to_i )
  end
  def >> val
    return IntegerVal.new( @val >> val.to_i )
  end
  def > val
    if val.kind_of? FloatVal then
      return BoolVal.new( @val.to_f > val.to_f )
    else
      return BoolVal.new( @val > val.to_i )
    end
  end
  def < val
    if val.kind_of? FloatVal then
      return BoolVal.new( @val.to_f < val.to_f )
    else
      return BoolVal.new( @val < val.to_i )
    end
  end
  def >= val
    if val.kind_of? FloatVal then
      return BoolVal.new( @val.to_f >= val.to_f )
    else
      return BoolVal.new( @val >= val.to_i )
    end
  end
  def <= val
    if val.kind_of? FloatVal then
      return BoolVal.new( @val.to_f <= val.to_f )
    else
      return BoolVal.new( @val <= val.to_i )
    end
  end
  def eq val # == val
    if val.kind_of? FloatVal then
      return BoolVal.new( @val.to_f == val.to_f )
    else
      return BoolVal.new( @val == val.to_i )
    end
  end
  def neq val # != val
    if val.kind_of? FloatVal then
      return BoolVal.new( @val.to_f != val.to_f )
    else
      return BoolVal.new( @val != val.to_i )
    end
  end
  def & val
    IntegerVal.new( @val & val.to_i )
  end
  def ^ val
    IntegerVal.new( @val ^ val.to_i )
  end
  def | val
    IntegerVal.new( @val | val.to_i )
  end
  def lAND # && val
    BoolVal.new( @val && val.to_i )
  end
  def lOR  # || val
    BoolVal.new( @val || val.to_i )
  end
  def cast( type )
    t = type.get_original_type   # typedef θ
    if t.kind_of? IntType then
      val = t.check_and_clip( @val, :IntType )
      return IntegerVal.new( val )
    elsif t.kind_of? FloatType then
      return FloatVal.new( @val )
    elsif t.kind_of? PtrType then
      return PointerVal.new( @val, type )
# mikan BoolType ؤΥ㥹ȤϤǤƤ褤ΤǤϡ
    else
      Generator.error( "integer value cannot cast to #{type.class}" )
      return nil
    end
  end

  def to_s
    if @str then
      @str
    else
      @val.to_s
    end
  end
  def to_i
    @val
  end
  def to_f
    @val.to_f
  end
end

#= BoolVal: bool ͤ򰷤饹
class BoolVal < BaseVal
#@val:: bool: true, false

  def initialize( val )
    @val = val
    raise "No boolean val" if val != true && val != false
  end

  def not # ! val
      BoolVal.new( ! @val )
  end
  def eq val # == val
    if val.kind_of? BoolVal then
      return BoolVal.new( @val.to_i == val.to_i )
    else
      Generator.error( "comparing bool value with '#{val.class}'" )
      return BoolVal.new( false )
    end
  end
  def neq val # != val
    if val.kind_of? BoolVal then
      return BoolVal.new( @val.to_i != val.to_i )
    else
      Generator.error( "comparing bool value with '#{val.class}'" )
      return BoolVal.new( false )
    end
  end
  def lAND # && val
    BoolVal.new( @val.to_i && val.to_i )
  end
  def lOR  # || val
    BoolVal.new( @val.to_i || val.to_i )
  end
  def cast( type )
    t = type.get_original_type   # typedef θ
    if @val then
      val = 1
    else
      val = 0
    end
    if t.kind_of? IntType then
      return IntegerVal.new( val )
    elsif t.kind_of? FloatType then
      return FloatVal.new( val )
    elsif t.kind_of? BoolType then
      return self
    else
      Generator.error( "bool value cannot cast to #{type.class}" )
      return nil
    end
  end

  def to_s
    if @val
      return "true"
    else
      return "false"
    end
  end
  def to_i
    return 0 if @val == false
    return 1
  end
  def to_f
    return 0.0 if @val == false
    return 1.0
  end

  attr_reader :val
end

#= FloatVal: ¿ͤ򰷤饹
class FloatVal < BaseVal
#@val:: Float
  def initialize( val )
    @val = val.to_f
  end

  def -@
    FloatVal.new( - @val )
  end
  def +@
    self
  end
  def * val
    FloatVal.new( @val * val.to_f )
  end
  def / val
    v2 = val.to_f   # to_f 2ɾʤ
    if v2 == 0.0 then
      Generator.error( "/ : divieded by zero" )
      return FloatVal.new( 1.0 )
    end
    return FloatVal.new( @val.to_f / v2 )
  end
  def % val
    v2 = val.to_f   # to_f 2ɾʤ
    if v2 == 0.0 then
      Generator.error( "% : divieded by zero" )
      return FloatVal.new( 1.0 )
    end
    return FloatVal.new( @val.to_f % v2 )
  end
  def + val
    FloatVal.new( @val + val.to_f )
  end
  def - val
    FloatVal.new( @val - val.to_f )
  end
  def > val
    BoolVal.new( @val > val.to_f )
  end
  def < val
    BoolVal.new( @val < val.to_f )
  end
  def >= val
    BoolVal.new( @val >= val.to_f )
  end
  def <= val
    BoolVal.new( @val <= val.to_f )
  end
  def eq val # == val
    BoolVal.new( @val == val.to_f )
  end
  def neq val # != val
    BoolVal.new( @val != val.to_f )
  end
  def cast( type )
    t = type.get_original_type   # typedef θ
    if t.kind_of? IntType then
      val = t.check_and_clip( @val, :FloatType )
      return IntegerVal.new( val )
    elsif t.kind_of? FloatType then
      return self
    else
      Generator.error( "floating value cannot cast to #{type}" )
      return self
    end
  end

  def to_i
    Generator.error( "convert floating value to integer without cast" )
    @val.to_i
  end
  def to_s
    @val.to_s
  end
  def to_f
    @val
  end
end

#= ʸƥ򰷤饹
class StringVal < BaseVal
#@str:: Token:
#@specifier:: Symbol: :WIDE, :NORMAL

  def initialize( str, spec = :NORMAL )
    @str = str
    @specifier = spec   # mikan L"str" wide ʸ̤б
  end

  #===
  #
  # string  cast ϤǤʤ mikan ݥ󥿷ؤ cast ϤǤ٤
  def cast type
    t = type.get_original_type   # typedef θ
    if t.kind_of? IntType then
      Generator.error( "string cannot cast to integer" )
    elsif t.kind_of? FloatType then
      Generator.error( "string cannot cast to float" )
    elsif t.kind_of? PtrType then
      Generator.error( "string cannot cast to pointer" )
    else
      Generator.error( "string cannot cast to #{type}" )
    end
  end
    
  def to_s
    @str.to_s
  end

  def val
    @str.to_s   # Token ǰƤ̾ (val Ф)
  end
end
